import java.awt.*;
import java.awt.event.*;
import Funkcije.*;

public class Prozor extends Frame {
	private Platno platno;
	private Funkcija f=null;
	private TextField xmin,xmax,ymin,ymax,a,b,c,d,k;
	private Button crtaj,novaZbirka,dodajFunkciju,izbrisiFunkcije,crtajSve;
	private Zbirka z=new Zbirka();
	private boolean zbirkaaa=false;
	
	private String funkcije[]={"sinus","poli","razl","oscil"},funkcija=null;
	
	private Prozor(){
		super("Funkcije");
		setBounds(100,100,400,350);
		setResizable(false);
		
		addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent d){ dispose(); }
		});
		
		setLayout(new BorderLayout());
		
		// NORTH
		Panel plo=new Panel();
		CheckboxGroup grupa=new CheckboxGroup();
		PromenaFunkcije PF=new PromenaFunkcije();
		for(int i=0;i<funkcije.length;i++){
			Checkbox radio=new Checkbox(funkcije[i]);
			radio.setCheckboxGroup(grupa);
			radio.addItemListener(PF);
			plo.add(radio);
		}	
		add(plo,"North");
		
		// EAST
		plo=new Panel(new GridLayout(4,2,0,55));
			plo.add(new Label("xmin:"));
			plo.add(xmin=new TextField());
			plo.add(new Label("xmax:"));
			plo.add(xmax=new TextField());
			plo.add(new Label("ymin:"));
			plo.add(ymin=new TextField());
			plo.add(new Label("ymax:"));
			plo.add(ymax=new TextField());
		add(plo,"West");
		
		// CENTER
		add(platno=new Platno(),"Center");
		platno.setBackground(Color.lightGray);
	
		// EAST
		plo=new Panel();
		plo.setLayout(new GridLayout(4,2,0,55));
			plo.add(new Label("a:"));
			plo.add(a=new TextField());
			plo.add(new Label("b:"));
			plo.add(b=new TextField());
			plo.add(new Label("c:"));
			plo.add(c=new TextField());
			plo.add(new Label("d:"));
			plo.add(d=new TextField());
		add(plo,"East");
		
		// SOUTH
		plo=new Panel();
		plo.add(new Label("k:"));
		plo.add(k=new TextField());
		plo.add(novaZbirka=new Button("Nova zbirka"));
		novaZbirka.addActionListener(new NovaZbirka());
		plo.add(dodajFunkciju=new Button("Dodaj"));
		dodajFunkciju.addActionListener(new DodajFunkciju());
		plo.add(izbrisiFunkcije=new Button("Izbrisi"));
		izbrisiFunkcije.addActionListener(new IzbrisiFunkcije());
		plo.add(crtaj=new Button("Crtaj"));
		crtaj.addActionListener(new StisakDugmeta());
		plo.add(crtajSve=new Button("Sve"));
		crtajSve.addActionListener(new CrtajSve());
		add(plo,"South");
	}
	
	private class NovaZbirka implements ActionListener{
		public void actionPerformed(ActionEvent d){
			try{
				z=new Zbirka(Integer.parseInt(k.getText()));
			}catch(NumberFormatException greska){}
		}
	}
	
	private class DodajFunkciju implements ActionListener{
		public void actionPerformed(ActionEvent d){
			if(f!=null)z.dodaj(f);
		}
	}
	
	private class IzbrisiFunkcije implements ActionListener{
		public void actionPerformed(ActionEvent d){
			z.izbaciSve();
		}
	}
	
	private class CrtajSve implements ActionListener{
		public void actionPerformed(ActionEvent d){
			zbirkaaa=true;
			platno.repaint();
		}
	}
	
	private class Platno extends Canvas{
		public void paint(Graphics g){
			if(funkcija!=null){
				try{
					double aa=Double.parseDouble(a.getText()),bb=Double.parseDouble(b.getText()),cc=Double.parseDouble(c.getText()),dd=Double.parseDouble(d.getText());
					if(funkcija.equals("sinus"))f=new Sinusoida(aa,bb,cc,dd);
					else if(funkcija.equals("poli"))f=new Polinom(aa,bb,cc,dd);
					else if(funkcija.equals("razl"))f=new Razlomak(aa,bb,cc,dd);
					else if(funkcija.equals("oscil"))f=new Oscilacije(aa,bb,cc,dd);
					
					double minx=Double.parseDouble(xmin.getText()),miny=Double.parseDouble(ymin.getText()),maxx=Double.parseDouble(xmax.getText()),maxy=Double.parseDouble(ymax.getText());
					int X,Y,XPret=(int)minx,YPret=(int)miny;
					
					if(zbirkaaa){
						for(int i=0;i<z.niz.length;i++){
							XPret=(int)minx;
							YPret=(int)miny;
							if(z.niz[i]!=null){
								for(double xx=minx;xx<maxx;xx++){
									double yy=z.niz[i].vrednost(xx);
									X=(int)((platno.getWidth()-1)*(xx-minx)/(maxx-minx));
									Y=(int)((platno.getHeight()-1)*(maxy-yy)/(maxy-miny));
									g.drawLine(XPret,YPret,X,Y);
									XPret=X;
									YPret=Y;
								}
							}
						}
					}else{
						for(double xx=minx;xx<maxx;xx++){
							double yy=f.vrednost(xx);
							X=(int)((platno.getWidth()-1)*(xx-minx)/(maxx-minx));
							Y=(int)((platno.getHeight()-1)*(maxy-yy)/(maxy-miny));
							g.drawLine(XPret,YPret,X,Y);
							XPret=X;
							YPret=Y;
						}
					}
				}catch(NumberFormatException greska){
					Font font=new Font("BBB",Font.BOLD,22);
					g.setFont(font);
					g.drawString("GRESKA",10,30);
				}
			}else{
				//platno.setBackground(Color.red);
				Font font=new Font("BBB",Font.BOLD,22);
				g.setFont(font);
				g.drawString("Izaberite Funkciju",10,30);
			}
		}
	} 
	
	private class PromenaFunkcije implements ItemListener{
		public void itemStateChanged(ItemEvent d){
			funkcija=((Checkbox)(d.getSource())).getLabel();
		}
	}
	
	private class StisakDugmeta implements ActionListener{
		public void actionPerformed(ActionEvent d){
			zbirkaaa=false;
			platno.repaint();
		}
	}
	
	public static void main(String[] args){
		new Prozor().setVisible(true);
	}
}
