import java.awt.*;
import java.awt.event.*;
import funkcije.*;

public class Grafik extends Frame{
	
	
	private Funkcija fun = new Poli();
	private double a,b,c,d, xmin,xmax,ymin,ymax;
	private Button dugme = new Button("Crtaj");
	private Platno platno = new Platno();
	private int sir,vis,n=300;
	private TextField tA = new TextField(),
					  tB = new TextField(),
					  tC = new TextField(),
					  tD = new TextField(),
					  tXmin = new TextField(),
					  tXmax = new TextField(),
					  tYmin = new TextField(),
					  tYmax = new TextField();
	
					  
	private Grafik() {
		super("Grafik funkcija");
		setBounds(200,200,300,220);
		setResizable(false);
		
		add(popuniGore(), "North");
		add(popuniLevo(), "West");
		add(popuniDesno(), "East");
		add(popuniDole(), "South");
		add(platno, "Center");
		platno.setBackground(Color.LIGHT_GRAY);
		setVisible(true);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent d) { dispose(); }
		});
	}
	
	private Panel popuniGore() {
		Panel ploca = new Panel();
		CheckboxGroup grupa = new CheckboxGroup();
		String[] nazivi = {"sinus", "poli", "razl", "oscil"};
		for(String s: nazivi) {
			Checkbox radio = new Checkbox(s, grupa, s.equals("poli"));
			ploca.add(radio);
			radio.addItemListener(new ItemListener() {
				public void itemStateChanged(ItemEvent d) {
					String s = ((Checkbox)d.getSource()).getLabel();
					if(s.equals("sinus"))
						fun = new Sin();
					else if(s.equals("poli"))
						fun = new Poli();
					else if(s.equals("razl"))
						fun = new Razlomak();
					else 
						fun = new Oscil();
				}
			});
		}
		return ploca;
 	}
	
	private Panel popuniLevo() {
		Panel ploca = new Panel(new GridLayout(4,2));
		ploca.add(new Label("xmin:"));
		ploca.add(tXmin);
		ploca.add(new Label("xmax:"));
		ploca.add(tXmax);
		ploca.add(new Label("ymin:"));
		ploca.add(tYmin);
		ploca.add(new Label("ymax:"));
		ploca.add(tYmax);
		return ploca;
	}
	
	private Panel popuniDesno() {
		Panel ploca = new Panel(new GridLayout(4,2));
		ploca.add(new Label("a:"));
		ploca.add(tA);
		ploca.add(new Label("b:"));
		ploca.add(tB);
		ploca.add(new Label("c:"));
		ploca.add(tC);
		ploca.add(new Label("d:"));
		ploca.add(tD);
		return ploca;
	}
	
	private Panel popuniDole() {
		Panel ploca = new Panel();
		ploca.add(dugme);
		dugme.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent d) {
				platno.repaint();
			}
		});
		return ploca;
	}
	
	private void uzmiParametre() throws NumberFormatException{
		a = Double.parseDouble(tA.getText());
		b = Double.parseDouble(tB.getText());
		c = Double.parseDouble(tC.getText());
		d = Double.parseDouble(tD.getText());
		xmin = Double.parseDouble(tXmin.getText());
		xmax = Double.parseDouble(tXmax.getText());
		ymin = Double.parseDouble(tYmin.getText());
		ymax = Double.parseDouble(tYmax.getText());
		sir = platno.getWidth();
		vis = platno.getHeight();
	}
	
	
	private class Platno extends Canvas {
		
		private int p(double x) {
			return (int) ((sir-1)* (x-xmin)/(xmax-xmin));
		}
		private int q(double y) {
			return (int) ((vis-1)* (ymax-y)/(ymax-ymin));
		}
		
		public void paint(Graphics g) {
			try {                               
				uzmiParametre();
				fun.postavi(a, b, c, d);
				g.setColor(Color.RED);
				
				double dx = (xmax-xmin)/n;
				boolean prva = true;
				int p0=0, q0=0;
				for(double x = xmin; x<=xmax; x+=dx) {
					double y = fun.f(x);
					if(!Double.isNaN(y)) {
						int p = p(x), q = q(y);
						if(!prva)
							g.drawLine(p0, q0, p, q);
						else
							prva = false;
						p0 = p; q0 = q;
					} else 
						prva = true;
				}
			} catch(NumberFormatException gr) {
				g.drawString("GRESKA", 20, 20);
			}
		}
	}
	
	public static void main(String[] args) {
		new Grafik();
	}
	
}
